<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable
                      class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search"
                       class="filter-item">搜索
            </el-button>
            <el-button @click="addRow" type="primary" icon="el-icon-plus"
                       class="filter-item">添加
            </el-button>
            <!--            <el-button @click="download" type="primary" icon="el-icon-download"
                                   :loading="downloading" class="filter-item">导出EXCEL
                        </el-button>-->
            <el-select v-model="status" class="filter-item" placeholder="筛选状态" clearable filterable
                       @change="getData">
                <el-option
                        v-for="item in statusOptions"
                        :label="item.label"
                        :value="item.value"
                        :key="item.value"
                />
            </el-select>
        </div>
        <el-table :data="tableData" row-key="id" ref="table"
                  header-row-class-name="table-header-row"
                  header-cell-class-name="table-header-cell"
                  row-class-name="table-row" cell-class-name="table-cell"
                  :height="tableHeight">
            <el-table-column v-if="multipleMode" align="center" type="selection"
                             width="50">
            </el-table-column>
            <el-table-column prop="id" label="ID" width="80">
            </el-table-column>
            <el-table-column prop="merchantId" label="商户ID"
            >
            </el-table-column>
            <el-table-column prop="name" label="名称"
            >
            </el-table-column>
            <el-table-column prop="introduction" label="简介"
            >
            </el-table-column>
            <el-table-column prop="img" label="图片"
            >
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                              :src="picList(row.img)[0]" fit="cover"
                              :preview-src-list="picList(row.img)?picList(row.img):[]"></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="inventory" label="库存"
            >
            </el-table-column>
            <el-table-column prop="totalSales" label="总销量"
            >
                <!--                    </el-table-column>
                                    <el-table-column prop="daySales" label="日销售"
                >-->
            </el-table-column>
            <el-table-column prop="likes" label="点赞"
            >
            </el-table-column>
            <el-table-column prop="amount" label="价格"
            >
            </el-table-column>
            <el-table-column prop="discountAmount" label="折扣"
            >
            </el-table-column>
            <el-table-column prop="signboard" label="招牌"
            >
                <template slot-scope="{row}">
                    <el-tag :type="row.signboard?'':'info'">{{row.signboard}}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="takeOff" label="下架"
            >
                <template slot-scope="{row}">
                    <el-tag :type="row.takeOff?'':'info'">{{row.takeOff}}</el-tag>
                </template>
            </el-table-column>
            <!--            <el-table-column prop="sort" label="排布"
                        >
                        </el-table-column>-->
            <el-table-column prop="isFullReduction" label="满减"
            >
                <template slot-scope="{row}">
                    <el-tag :type="row.isFullReduction?'':'info'">{{row.isFullReduction}}</el-tag>
                </template>
            </el-table-column>
            <el-table-column prop="week" label="时间"
            >
            </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"
            >
            </el-table-column>
            <el-table-column
                    label="操作"
                    align="center"
                    fixed="right"
                    min-width="150">
                <template slot-scope="{row}">
                    <!-- <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>-->
                    <el-button @click="take(row)" type="warning" size="mini" plain v-if="row.status === 'PASS'">
                        {{row.takeOff?'上架':'下架'}}
                    </el-button>
                    <el-button @click="deleteRow(row)" type="info" size="mini" plain v-if="row.status !== 'PENDING'">
                        删除
                    </el-button>
                    <el-button
                            v-if="row.status === 'PENDING'"
                            :loading="row.loading"
                            @click="audit(row, true)"
                            type="primary"
                            size="mini"
                            plain
                    >通过
                    </el-button
                    >
                    <el-button
                            v-if="row.status === 'PENDING'"
                            @click="deny(row)"
                            type="danger"
                            size="mini"
                            plain
                    >拒绝
                    </el-button
                    >
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!--    <div class="multiple-mode-wrapper">
                    <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                    <el-button-group v-else>
                        <el-button @click="operation1">批量操作1</el-button>
                        <el-button @click="operation2">批量操作2</el-button>
                        <el-button @click="toggleMultipleMode(false)">取消</el-button>
                    </el-button-group>
                </div>-->
            <el-pagination background @size-change="onSizeChange"
                           @current-change="onCurrentChange" :current-page="page"
                           :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize"
                           layout="total, sizes, prev, pager, next, jumper"
                           :total="totalElements">
            </el-pagination>
        </div>

    </div>
</template>
<script>
    import {mapState} from "vuex";
    import pageableTable from "@/mixins/pageableTable";

    export default {
        name: 'GoodsList',
        mixins: [pageableTable],
        created() {
            this.getData();
        },
        data() {
            return {
                multipleMode: false,
                search: "",
                url: "/goods/all",
                downloading: false,
                statusOptions: [{"label": "待处理", "value": "PENDING"}, {
                    "label": "成功", "value": "PASS"
                }, {"label": "失败", "value": "DENY"}],
                status: '',

            }
        },
        computed: {
            selection() {
                return this.$refs.table.selection.map(i => i.id);
            }
        },
        methods: {
            picList(row) {
                if (row) {
                    return row.split(",");
                } else {
                    return "";
                }
            },
            statusFormatter(row, column, cellValue, index) {
                let selectedOption = this.statusOptions.find(i => i.value === cellValue);
                if (selectedOption) {
                    return selectedOption.label;
                }
                return '';
            },
            beforeGetData() {
                let data = {}
                if (this.search) {
                    data.search = this.search;
                }
                if (this.status) {
                    data.query.status = this.status;
                }
                return data;
            },
            toggleMultipleMode(multipleMode) {
                this.multipleMode = multipleMode;
                if (!multipleMode) {
                    this.$refs.table.clearSelection();
                }
            },
            addRow() {
                this.$router.push({
                    path: "/goodsEdit",
                    query: {
                        ...this.$route.query
                    }
                });
            },
            editRow(row) {
                this.$router.push({
                    path: "/goodsEdit",
                    query: {
                        id: row.id
                    }
                });
            },
            download() {
                this.downloading = true;
                this.$axios
                    .get("/goods/excel", {
                        responseType: "blob",
                        params: {size: 10000}
                    })
                    .then(res => {
                        console.log(res);
                        this.downloading = false;
                        const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                        const link = document.createElement("a");
                        link.href = downloadUrl;
                        link.setAttribute(
                            "download",
                            res.headers["content-disposition"].split("filename=")[1]
                        );
                        document.body.appendChild(link);
                        link.click();
                        link.remove();
                    })
                    .catch(e => {
                        console.log(e);
                        this.downloading = false;
                        this.$message.error(e.error);
                    });
            },
            operation1() {
                this.$notify({
                    title: '提示',
                    message: this.selection
                });
            },
            operation2() {
                this.$message('操作2');
            },
            deleteRow(row) {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/goods/del/${row.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                }).catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('删除取消');
                    } else {
                        this.$message.error('删除失败');
                    }
                })
            },
            take(row) {
                /*  this.$confirm('确认要下架么？', '提示', {type: 'primary'}).then(() => {
                      return this.$http.post({
                          url: '/goods/take',
                          data: {
                              id: row.id,
                          }
                      })
                  }).then(() => {
                      this.$message.success('下架成功');
                      this.getData();
                  }).catch(action => {

                  })*/
                this.$set(row, 'loading', true);
                this.$http
                    .get('/goods/take', {
                        id: row.id,
                    })
                    .then(res => {
                        this.$set(row, 'loading', false);
                        this.$message.success('OK');
                        this.getData();
                    })
                    .catch(e => {
                        console.log(e);
                        this.$set(row, 'loading', false);
                        this.$message.error(e.error);
                    });
            },
            audit(row, pass) {
                this.$set(row, 'loading', true);
                this.$http
                    .get('/goods/audit', {
                        id: row.id,
                        pass: pass
                    })
                    .then(res => {
                        this.$set(row, 'loading', false);
                        this.$message.success('OK');
                        this.getData();
                    })
                    .catch(e => {
                        console.log(e);
                        this.$set(row, 'loading', false);
                        this.$message.error(e.error);
                    });
            },
            deny(row) {
                this.$prompt('请输入理由', '提示', {
                    inputType: 'textarea'
                })
                    .then(res => {
                        // console.log(res);
                        if (res.value) {
                            this.$alert('确定拒绝通过？', '提示', {
                                showCancelButton: true
                            })
                                .then(() => {
                                    return this.$http.get('/goods/audit', {
                                        id: row.id,
                                        pass: false,
                                        reason: res.value
                                    });
                                })
                                .then(res => {
                                    this.$message.success('拒绝通过成功');
                                    this.$router.go(0);
                                })
                                .catch(() => {
                                    this.$message.error(res.error || '拒绝通过失败');
                                });
                        }
                    })
                    .catch(() => {
                    });
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
